/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (I)         *
 *            - vO~O̊bE\[XECxg -             *
 *                                                                     *
 *      Copyright 1994,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static Widget text, dialog, label;

/* ut@Cvj[̍ڂI΂ꂽƂ̃R[obN */
static void FileMenuCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    int menu_item = (int)client_data;  /* I΂ꂽj[ڂ̔ԍ */
    printf("File Menu: item %d is selected\n", menu_item);

    if (menu_item == 0)  /* 0 Ԗڂ̃j[ (uVKv) Ȃ */
        XmTextSetString(text, "");  /* eLXg̓e */

    if (menu_item == 1)  /* 1 Ԗڂ̃j[ (uI[vv) Ȃ */
        XtManageChild(dialog);  /* t@CEZNVE_CAOo */

    if (menu_item == 3)  /* 3 Ԗڂ̃j[ (uIv) Ȃ */
        exit(0);         /* vOI */
}

/* _CAO [] {^ꂽƂ̃R[obN */
static void OpenFileCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    char *filename;
    FILE *fp;
    char buff[BUFSIZ];
    XmFileSelectionBoxCallbackStruct *cb =
                (XmFileSelectionBoxCallbackStruct *)call_data;

    /* t@C̕o */
    XmStringGetLtoR(cb->value, XmFONTLIST_DEFAULT_TAG, &filename);

    /* t@CI[văeLXgɐݒ */
    XmTextSetString(text, "");  /* eLXg̓e */
    fp = fopen(filename, "r");  /* t@CI[v */
    while (fgets(buff, BUFSIZ, fp) != NULL) {  /* t@Cǂݍ */
        /* ǂݍ񂾃f[^eLXgɒǉ */
        XmTextInsert(text, XmTextGetLastPosition(text), buff);
    }
    fclose(fp);
    XtFree(filename);

    /* t@C̃xɕ\ */
    XtVaSetValues(label, XmNlabelString, cb->value, NULL);
    XtUnmanageChild(dialog); /* _CAO */
}

/* j[o[ƃv_EEj[쐬 */
static Widget CreateMenu(parent)
    Widget parent;
{
    Widget  menubar, filemenu;

    /* j[o[쐬 */
    menubar = XmVaCreateSimpleMenuBar(parent, "menubar",
                  XmVaCASCADEBUTTON, NULL, NULL,  /* ut@Cvj[ */
                  NULL);
    XtManageChild(menubar);

    /* ut@Cvv_EEj[쐬 */
    filemenu = XmVaCreateSimplePulldownMenu(menubar, "filemenu", 0, FileMenuCB,
                  XmVaPUSHBUTTON, NULL, NULL, NULL, NULL,  /* uVKv */
                  XmVaPUSHBUTTON, NULL, NULL, NULL, NULL,  /* uI[vv */
                  XmVaPUSHBUTTON, NULL, NULL, NULL, NULL,  /* uۊǁv */
                  XmVaSEPARATOR,  /* Zp[^ (j[ڂ̋؂) */
                  XmVaPUSHBUTTON, NULL, NULL, NULL, NULL,  /* uIv */
                  NULL);

    return(menubar);
}

/* I΂ꂽeLXgNbv{[hɃRs[ */
static void CopyCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    XmTextCopy(text, XtLastTimestampProcessed(XtDisplay(text)));
}

/* I΂ꂽeLXgNbv{[hɃJbg */
static void CutCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    XmTextCut(text, XtLastTimestampProcessed(XtDisplay(text)));
}

/* Nbv{[h̃f[^eLXgɃy[Xg */
static void PasteCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    XmTextPaste(text);
}

/* R}ḧ쐬 */
static Widget CreateCommandArea(parent)
    Widget parent;
{
    Widget command, copy, cut, paste;
    Arg    al[20];
    int    ac;

    ac = 0;
    command = XmCreateRowColumn(parent, "command", al, ac);
    XtManageChild(command);

    /* [Rs[]A[Jbg]A[y[Xg] {^쐬 */
    ac = 0;
    copy = XmCreatePushButton(command, "copy", al, ac);
    XtManageChild(copy);
    ac = 0;
    cut = XmCreatePushButton(command, "cut", al, ac);
    XtManageChild(cut);
    ac = 0;
    paste = XmCreatePushButton(command, "paste", al, ac);
    XtManageChild(paste);

    XtAddCallback(copy,  XmNactivateCallback, CopyCB,  NULL);
    XtAddCallback(cut,   XmNactivateCallback, CutCB,   NULL);
    XtAddCallback(paste, XmNactivateCallback, PasteCB, NULL);

    return command;
}

/* bZ[Ẅ쐬 */
static Widget CreateMessageArea(parent)
    Widget parent;
{
    Widget message, frame, ftitle, form, ltitle;
    Arg    al[20];
    int    ac;

    ac = 0;
    XtSetArg(al[ac], XmNmarginWidth,  8); ac++;
    XtSetArg(al[ac], XmNmarginHeight, 8); ac++;
    message = XmCreateRowColumn(parent, "message", al, ac);
    XtManageChild(message);

    /* t[̊Ogň͂ */
    ac = 0;
    XtSetArg(al[ac], XmNmarginWidth,  8); ac++;
    XtSetArg(al[ac], XmNmarginHeight, 8); ac++;
    frame = XmCreateFrame(message, "frame", al, ac);
    XtManageChild(frame);

    /* t[Ƀ^Cgt */
    ac = 0;
    XtSetArg(al[ac], XmNchildType,                XmFRAME_TITLE_CHILD); ac++;
    XtSetArg(al[ac], XmNchildHorizontalAlignment, XmALIGNMENT_CENTER); ac++;
    XtSetArg(al[ac], XmNmarginWidth,              10); ac++;
    ftitle = XmCreateLabel(frame, "ftitle", al, ac);
    XtManageChild(ftitle);

    /* tH[ŎqEBWFbgCAEg */
    ac = 0;
    form = XmCreateForm(frame, "form", al, ac);
    XtManageChild(form);

    /* [t@C:] ̃x𒆉̂ɒu */
    ac = 0;
    XtSetArg(al[ac], XmNtopAttachment,    XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNleftAttachment,   XmATTACH_POSITION); ac++;
    XtSetArg(al[ac], XmNleftPosition,     0); ac++;
    XtSetArg(al[ac], XmNrightAttachment,  XmATTACH_POSITION); ac++;
    XtSetArg(al[ac], XmNrightPosition,    50); ac++;
    XtSetArg(al[ac], XmNrightOffset,      4); ac++;
    XtSetArg(al[ac], XmNalignment,        XmALIGNMENT_END); ac++;
    XtSetArg(al[ac], XmNresizable,        False); ac++;
    ltitle = XmCreateLabel(form, "ltitle", al, ac);
    XtManageChild(ltitle);

    /* I[vt@C𒆉̂Eɒu */
    ac = 0;
    XtSetArg(al[ac], XmNtopAttachment,    XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNleftAttachment,   XmATTACH_POSITION); ac++;
    XtSetArg(al[ac], XmNleftPosition,     50); ac++;
    XtSetArg(al[ac], XmNleftOffset,       4); ac++;
    XtSetArg(al[ac], XmNrightAttachment,  XmATTACH_POSITION); ac++;
    XtSetArg(al[ac], XmNrightPosition,    100); ac++;
    XtSetArg(al[ac], XmNalignment,        XmALIGNMENT_BEGINNING); ac++;
    XtSetArg(al[ac], XmNresizable,        False); ac++;
    label = XmCreateLabel(form, "label", al, ac);
    XtManageChild(label);

    return message;
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, mainwin, menubar, work, command, message;
    Arg    al[20];
    int    ac;

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Editor", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
        /* CEEBhE؂ (Zp[^) \ */
    XtSetArg(al[ac], XmNshowSeparator, True); ac++;
        /* R}ḧ[N̈̉ɒu */
    XtSetArg(al[ac], XmNcommandWindowLocation, XmCOMMAND_BELOW_WORKSPACE); ac++;
        /* CEEBhE쐬 */
    mainwin = XmCreateMainWindow(toplevel, "mainwin", al, ac);
    XtManageChild(mainwin);

    menubar = CreateMenu(mainwin); /* j[쐬 */

        /* [N̈ */
    ac = 0;
    work = XmCreateRowColumn(mainwin, "work", al, ac);
    XtManageChild(work);
    ac = 0;
    text = XmCreateText(work, "text", al, ac);
    XtManageChild(text);

        /* R}ḧ */
    command = CreateCommandArea(mainwin);
        /* bZ[Ẅ */
    message = CreateMessageArea(mainwin);

        /* ëCEEBhEɔzu */
    XmMainWindowSetAreas(mainwin, menubar, command, NULL, NULL, work);
        /* bZ[Ẅ̓\[XŐݒ */
    XtVaSetValues(mainwin, XmNmessageWindow, message, NULL);

        /* t@CEZNVE_CAO쐬 */
    ac = 0;
    dialog = XmCreateFileSelectionDialog(toplevel, "dialog", al, ac);
    XtAddCallback(dialog, XmNokCallback, OpenFileCB, NULL);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}
