/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (I)         *
 *            - vO~O̊bE\[XECxg -             *
 *                                                                     *
 *      Copyright 1994,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

#define INTERVAL  (0.5 * 1000)  /* ^CAEg */
#define PIE       (60 * 64)     /* `~(pC)̊px */
#define ROTATION  (20 * 64)     /* ~(pC)]px */

static void TimeoutCB();
static Widget canvas;  /* ~(pC)`h[GAEEBWFbg */
static XtIntervalId timeout_id;  /* ^CAEgER[obN ID */
static GC gc;  /* OtBbNEReLXg (Xlib ̕`ɕKv) */
static int angle = (90 * 64) - PIE;  /* ŏ̉~ʂ̊Jnpx */

/* [Jn] {^ƌĂяo */
static void StartCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget start = (Widget)w, stop  = (Widget)client_data;

    /* ^CAEgER[obNo^ */
    timeout_id = XtAppAddTimeOut(XtWidgetToApplicationContext(canvas),
                                 INTERVAL, TimeoutCB, NULL);
    XtSetSensitive(start, False);  /* [Jn] {^gȂ */
    XtSetSensitive(stop, True);    /* [~] {^g悤ɂ */
}

/* ^CAEgER[obN */
static void TimeoutCB(client_data, id)
    XtPointer     client_data;  /* o^ɓnĂNCAgEf[^ */
    XtIntervalId *id;           /* ^CAEgER[obN ID */
{
    XClearWindow(XtDisplay(canvas), XtWindow(canvas)); /* EBhENA */
    XFillArc(XtDisplay(canvas), XtWindow(canvas), gc,  /* ~(pC)` */
             50, 50, 100, 100, angle, PIE);
    /* Ăу^CAEgER[obNĂяo悤ɂ */
    timeout_id = XtAppAddTimeOut(XtWidgetToApplicationContext(canvas),
                                 INTERVAL, TimeoutCB, NULL);
    angle -= ROTATION;  /* ɕ`~ʂ̊JnpxvZĂ */
    if (angle < 0) angle += (360 * 64);
}

/* [~] {^ƌĂяo */
static void StopCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget start = (Widget)client_data, stop  = (Widget)w;

    /* ^CAEgER[obN폜 */
    XtRemoveTimeOut(timeout_id);

    XtSetSensitive(start, True);  /* [Jn] {^g悤ɂ */
    XtSetSensitive(stop, False);  /* [~] {^gȂ */
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, bboard, control, start, stop;
    Arg    al[20];
    int    ac;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Timeoutcb", NULL, 0,
                               &argc, argv, NULL, al, ac);
    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    ac = 0;
    bboard = XmCreateBulletinBoard(panel, "bboard", al, ac);
    XtManageChild(bboard);

    ac = 0;
    canvas = XmCreateDrawingArea(bboard, "canvas", al, ac);
    XtManageChild(canvas);

    ac = 0;
    control = XmCreateRowColumn(panel, "control", al, ac);
    XtManageChild(control);

    ac = 0;
    start = XmCreatePushButton(control, "start", al, ac);
    XtManageChild(start);

    ac = 0;
    /* ŏ [~] {^gȂĂ */
    XtSetArg(al[ac], XmNsensitive, False); ac++;
    stop = XmCreatePushButton(control, "stop", al, ac);
    XtManageChild(stop);

    XtAddCallback(start, XmNactivateCallback, StartCB, stop);
    XtAddCallback(stop, XmNactivateCallback, StopCB, start);

    XtRealizeWidget(toplevel);

    /* OtBbNEReLXg𐶐A`}`̐Fɐݒ */
    gc = XCreateGC(XtDisplay(canvas), XtWindow(canvas), NULL, NULL);
    XSetForeground(XtDisplay(canvas), gc, BlackPixelOfScreen(XtScreen(canvas)));

    XtAppMainLoop(app_context);
}
